/**************************************************************************

Copyright (c) 2002 Dmitry Vukolov <dvukol@rosmail.ru>
Portions copyright (c) 2000 Palm, Inc. or its subsidiaries.
All rights reserved.

This is free software, licensed under the GNU Public License v2.
See the file COPYING for details.

**************************************************************************/

#include <PalmOS.h>
#include "commondb.h"

MemPtr AppInfoGetPtr(DmOpenRef dbP)
{
	UInt16 cardNo;
	LocalID appInfoID;

	if (DmOpenDatabaseInfo(dbP, NULL, NULL, NULL, &cardNo, NULL))
		return NULL;
	appInfoID = DmGetAppInfoID(dbP);
	if (appInfoID == NULL)
		return NULL;
	else
		return MemLocalIDToLockedPtr(appInfoID, cardNo);
}

void
ConvertDB(UInt32 DBType, UInt32 DBCreator,
	  CONVSTAGEFUNC ConvertAppInfo, CONVSTAGEFUNC ConvertRecord)
{
	DmOpenRef dbP;
	MemHandle recordH;
	MemPtr recordP, appInfoP;
	UInt16 NumRecords, index;

	dbP = DmOpenDatabaseByTypeCreator(DBType, DBCreator,
					  dmModeReadWrite |
					  dmModeShowSecret |
					  dmModeExclusive);
	if (dbP != NULL) {
		if (ConvertAppInfo != NULL) {
			appInfoP = AppInfoGetPtr(dbP);
			if (appInfoP != NULL)
				(*ConvertAppInfo) (appInfoP);
			MemPtrUnlock(appInfoP);
		}

		if (ConvertRecord != NULL) {
			NumRecords = DmNumRecords(dbP);
			for (index = 0; index < NumRecords; index++) {
				recordH = DmGetRecord(dbP, index);
				if (recordH == NULL)
					continue;

				recordP = MemHandleLock(recordH);
				(*ConvertRecord) (recordP);
				MemPtrUnlock(recordP);

				DmReleaseRecord(dbP, index, false);
			}
		}
		DmCloseDatabase(dbP);
	}
}
