/**************************************************************************

Copyright (c) 2002 Dmitry Vukolov <dvukol@rosmail.ru>

This is free software, licensed under the GNU Public License v2.
See the file COPYING for details.

**************************************************************************/

#include <PalmOS.h>
#include "launcherdb.h"
#include "commondb.h"
#include "convert.h"

/**********************************************************
        Private definitions:
***********************************************************/
void LauncherConvAppInfo(MemPtr AppInfoP);

#define launcherDBType      'DATA'
#define launcherDBCreator   sysFileCLauncher

typedef struct {
	UInt16 renamedCategories;	// bitfield of categories with a different name
	Char categoryLabels[dmRecNumCategories][dmCategoryLength];
	//...
} LauncherAppInfoType;

typedef LauncherAppInfoType *LauncherAppInfoPtr;


/**********************************************************
        Converting Functions:
***********************************************************/

void LauncherConvAppInfo(MemPtr RecordP)
{
	Int16 index;
	Char *p;
	LauncherAppInfoPtr appInfoP;

	appInfoP = (LauncherAppInfoPtr) RecordP;

	p = (Char *) appInfoP->categoryLabels;
	for (index = 0; index < dmRecNumCategories; index++) {
		ConvertDBStr(p, appInfoP);
		p += dmCategoryLength;
	}
}


void LauncherConvert()
{
	ConvertDB(launcherDBType, launcherDBCreator, LauncherConvAppInfo,
		  NULL);
}
