/**************************************************************************

Copyright (c) 2002 Dmitry Vukolov <dvukol@rosmail.ru>
Portions copyright (c) 2000 Palm, Inc. or its subsidiaries.
All rights reserved.

This is free software, licensed under the GNU Public License v2.
See the file COPYING for details.

**************************************************************************/

#include <PalmOS.h>
#include "memodb.h"
#include "commondb.h"
#include "convert.h"

/**********************************************************
        Private definitions:
***********************************************************/
void MemoConvAppInfo(MemPtr AppInfoP);
void MemoConvRecord(MemPtr RecordP);

#define memoDBType      'DATA'
#define memoDBCreator   sysFileCMemo

typedef struct {
	UInt16 renamedCategories;	// bitfield of categories with a different name
	Char categoryLabels[dmRecNumCategories][dmCategoryLength];
	UInt8 categoryUniqIDs[dmRecNumCategories];
	UInt8 lastUniqID;
	UInt8 reserved1;
	UInt16 reserved2;
	UInt16 reserved3;
	UInt8 sortOrder;
	UInt8 reserved;
} MemoAppInfoType;

typedef MemoAppInfoType *MemoAppInfoPtr;

typedef struct {
	char note;		// null terminated
	UInt8 reserved;
} MemoDBRecordType;

typedef MemoDBRecordType *MemoDBRecordPtr;

/**********************************************************
        Converting Functions:
***********************************************************/

void MemoConvAppInfo(MemPtr RecordP)
{
	Int16 index;
	Char *p;
	MemoAppInfoPtr appInfoP;

	appInfoP = (MemoAppInfoPtr) RecordP;

	p = (Char *) appInfoP->categoryLabels;
	for (index = 0; index < dmRecNumCategories; index++) {
		ConvertDBStr(p, appInfoP);
		p += dmCategoryLength;
	}
}


void MemoConvRecord(MemPtr RecordP)
{
	MemoDBRecordPtr record;

	record = (MemoDBRecordPtr) RecordP;
	ConvertDBStr(&record->note, RecordP);
}

void MemoConvert()
{
	ConvertDB(memoDBType, memoDBCreator, MemoConvAppInfo,
		  MemoConvRecord);
}
