/**************************************************************************

Copyright (c) 2002 Dmitry Vukolov <dvukol@rosmail.ru>
Portions copyright (c) 2000 Palm, Inc. or its subsidiaries.
All rights reserved.

This is free software, licensed under the GNU Public License v2.
See the file COPYING for details.

**************************************************************************/

#include <PalmOS.h>
#include "tododb.h"
#include "commondb.h"
#include "convert.h"

/**********************************************************
        Private definitions:
***********************************************************/
void ToDoConvAppInfo(MemPtr AppInfoP);
void ToDoConvRecord(MemPtr RecordP);

#define todoDBType      'DATA'
#define todoDBCreator   sysFileCToDo

typedef struct {
	UInt16 renamedCategories;	// bitfield of categories with a different name
	Char categoryLabels[dmRecNumCategories][dmCategoryLength];
	UInt8 categoryUniqIDs[dmRecNumCategories];
	UInt8 lastUniqID;
	UInt8 reserved1;
	UInt16 reserved2;
	UInt16 dirtyAppInfo;
	UInt8 sortOrder;
	UInt8 reserved3;
} ToDoAppInfoType;

typedef ToDoAppInfoType *ToDoAppInfoPtr;


typedef struct {
	DateType dueDate;
	UInt8 priority;		// high bit is complete flag
	Char description;
} ToDoDBRecordType;

typedef ToDoDBRecordType *ToDoDBRecordPtr;


/**********************************************************
        Converting Functions:
***********************************************************/

void ToDoConvAppInfo(MemPtr RecordP)
{
	Int16 index;
	Char *p;
	ToDoAppInfoPtr appInfoP;

	appInfoP = (ToDoAppInfoPtr) RecordP;

	p = (Char *) appInfoP->categoryLabels;
	for (index = 0; index < dmRecNumCategories; index++) {
		ConvertDBStr(p, appInfoP);
		p += dmCategoryLength;
	}
}


void ToDoConvRecord(MemPtr RecordP)
{
	Char *p;
	ToDoDBRecordPtr record;

	record = (ToDoDBRecordPtr) RecordP;
	p = &record->description;

	ConvertDBStr(p, record);
	p += StrLen(p) + 1;
	ConvertDBStr(p, record);
}


void ToDoConvert()
{
	ConvertDB(todoDBType, todoDBCreator, ToDoConvAppInfo,
		  ToDoConvRecord);
}
